/**
* Copyright 2020 Huawei Technologies Co., Ltd
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at

* http://www.apache.org/licenses/LICENSE-2.0

* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.

* File sample_process.h
* Description: handle acl resource
*/
#pragma once

#include <iostream>
#include <mutex>
#include <unistd.h>

#include "acl/acl.h"
#include "atlas_model.h"
#include "dvpp_process.h"
#include "video_encode.h"


using namespace std;

class DoProcess{
public:
    DoProcess();
    ~DoProcess();

    AtlasError Init();
    AtlasError Set(uint32_t width, uint32_t height);
    AtlasError Process(ImageData& image);
private:
    AtlasError InitResource();
    void DestroyResource();
private:
    int32_t deviceId_;
    aclrtContext context_;
    aclrtStream stream_;

    DvppProcess dvpp_;
    VideoEncode encoder_;
    aclrtRunMode runMode_;

    bool isInited_;
};

