/**
* Copyright 2020 Huawei Technologies Co., Ltd
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at

* http://www.apache.org/licenses/LICENSE-2.0

* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.

* File dvpp_process.h
* Description: handle dvpp process
*/
#pragma once
#include <cstdint>

#include "acl/acl.h"
#include "acl/ops/acl_dvpp.h"
#include "atlas_utils.h"

/**
 * DvppProcess
 */
class DvppProcess {
public:
    DvppProcess();
    ~DvppProcess();

    AtlasError InitResource(aclrtStream& stream);
    AtlasError Resize(ImageData& dest,ImageData& src, 
                      uint32_t width, uint32_t height);
    AtlasError JpegD(ImageData& destYuv, ImageData& srcJpeg);
    AtlasError JpegE(ImageData& destJpeg, ImageData& srcYuv);
    AtlasError Crop(ImageData& dest, ImageData& src,
                         uint32_t lt_horz, uint32_t lt_vert,
                         uint32_t rb_horz, uint32_t rb_vert);

    void DestroyResource();

protected:
    int isInitOk_;
    aclrtStream stream_;
    acldvppChannelDesc *dvppChannelDesc_;

    bool isReleased_;
};

