中文|[English](README.md)

**本样例为大家学习昇腾软件栈提供参考，非商业目的！**

**本README只提供命令行方式运行样例的指导，如需在Mindstudio下运行样例，请参考[Mindstudio运行图片样例wiki](https://gitee.com/ascend/samples/wikis/Mindstudio%E8%BF%90%E8%A1%8C%E5%9B%BE%E7%89%87%E6%A0%B7%E4%BE%8B?sort_id=3164874)。**

## 黑白图像上色样例

功能：使用colorization模型对输入的黑白图片进行上色推理。    
样例输入：待推理的jpg图片。    
样例输出：推理后的jpg图片。

## 适配要求

本产品的适配要求如下表，如不符合适配要求，样例无法运行成功。
| 适配项 | 适配条件 | 备注 |
|---|---|---|
| 适配版本 | >3.0.0 | 版本信息请参考[版本说明](https://ascend.huawei.com/zh/#/software/cann/notice) |
| 适配产品 | A200DK/A300([ai1s](https://support.huaweicloud.com/productdesc-ecs/ecs_01_0047.html#ecs_01_0047__section78423209366))  | 产品说明请参考[硬件平台](https://ascend.huawei.com/zh/#/hardware/product) |


### 前提条件

部署此Sample前，需要准备好以下环境：

- 请确认已按照[环境准备和依赖安装](../../../environment)准备好环境。    
- 已完成对应产品的开发环境和运行环境安装。

### 软件准备

1. 获取源码包。

   可以使用以下两种方式下载，请选择其中一种进行源码准备。   
    - 命令行方式下载（下载时间较长，但步骤简单）。    
       开发环境，非root用户命令行中执行以下命令下载源码仓。    
       ```cd $HOME```     
       ```git clone https://gitee.com/ascend/samples.git```   
    - 压缩包方式下载（下载时间较短，但步骤稍微复杂）。    
        1. samples仓右上角选择 **克隆/下载** 下拉框并选择 **下载ZIP**。    
        2. 将ZIP包上传到开发环境中的普通用户家目录中，例如 **$HOME/ascend-samples-master.zip**。     
        3. 开发环境中，执行以下命令，解压zip包。     
            ```cd $HOME```    
            ```unzip ascend-samples-master.zip```

2. 模型转换。

    **注：请确认环境变量已经在[环境准备和依赖安装](../../../environment)中配置完成**    
    |  **模型名称**  |  **模型说明**  |  **模型下载路径**  |
    |---|---|---|
    |  colorization| 黑白图像上色推理模型。  |  请参考[modelzoo仓ATC_colorization_caffe_AE](https://gitee.com/ascend/ModelZoo-TensorFlow/tree/master/TensorFlow/contrib/cv/colorization/ATC_colorization_caffe_AE)目录中README.md下载原始模型章节下载模型和权重文件。 |

    为了方便下载，在这里直接给出原始模型下载及模型转换命令,可以直接拷贝执行。也可以参照上表在modelzoo中下载并手工转换，以了解更多细节。     
    ```cd $HOME/samples/cplusplus/level2_simple_inference/6_other/colorization/model```     
    ```wget https://modelzoo-train-atc.obs.cn-north-4.myhuaweicloud.com/003_Atc_Models/AE/ATC%20Model/colorization/colorization.prototxt```    
    ```wget https://modelzoo-train-atc.obs.cn-north-4.myhuaweicloud.com/003_Atc_Models/AE/ATC%20Model/colorization/colorization.caffemodel```    
    ```atc --input_shape="data_l:1,1,224,224" --weight="./colorization.caffemodel" --input_format=NCHW --output="colorization" --soc_version=Ascend310 --framework=0 --model="./colorization.prototxt"```

    ![](https://images.gitee.com/uploads/images/2020/1106/160652_6146f6a4_5395865.gif "icon-note.gif") **说明：**  
    > - 模型转换时，如果报错找不到atc，请按照[环境准备和依赖安装](../../../environment)设置模型转换所需的相关环境变量！

### 样例部署

执行以下命令，执行编译脚本，开始样例编译。   
```cd $HOME/samples/cplusplus/level2_simple_inference/6_other/colorization/scripts```    
```bash sample_build.sh```

### 样例运行

**注：开发环境与运行环境合一部署，请跳过步骤1，直接执行[步骤2](#step_2)即可。**   

1. 执行以下命令,将开发环境的 **colorization** 目录上传到运行环境中，例如 **/home/HwHiAiUser**，并以HwHiAiUser（运行用户）登录运行环境（Host）。    
    ```scp -r $HOME/samples/cplusplus/level2_simple_inference/6_other/colorization HwHiAiUser@xxx.xxx.xxx.xxx:/home/HwHiAiUser```    
    ```ssh HwHiAiUser@xxx.xxx.xxx.xxx```     
    ```cd $HOME/colorization/scripts```    
    ![](https://images.gitee.com/uploads/images/2020/1106/160652_6146f6a4_5395865.gif "icon-note.gif") **说明：**  
    > - **xxx.xxx.xxx.xxx**为运行环境ip，200DK在USB连接时一般为192.168.1.2，300（ai1s）为对应的公网ip。

2. <a name="step_2"></a>执行运行脚本，开始样例运行。         
    ```bash sample_run.sh```      

### 查看结果

运行完成后，会在运行环境的命令行中打印出推理结果,并在$HOME/colorization/out/output目录下生成推理后的图片。