# 对弈引擎模块开发文档

对弈引擎主要负责AI的下棋策略计算，目前主要是根据传统搜索方法实现。
后续考虑使用类似AlphaGoZero的基于神经网络的方法去替换现有引擎，让AI更加智能。

## 1. 总体功能

主要负责计算当前局面下AI的策略，也负责检查对局是否结束、胜利方是谁等棋局基本信息。

## 2. 概要设计

代码参考象棋小巫师的demo演示版本，根据GNU开源协议修改，模块化对弈引擎之后不再带有历史走法表、开局库。

主要调用函数为pos.IsMate()和ResponseMove()，来实现判断棋局是否结束的功能以及让AI作出对应的下棋策略。

### 2.1 接口设计

整个对弈引擎最终被封装成接收下棋方和棋局信息，返回棋局结束状态、胜负方、下棋步法的一个模块。
因此，这边的接口需要处理这些对应的信息。

针对棋局信息，由于对弈引擎内部使用比较特殊的棋子类别标识，与分类引擎有所不同，
所以需要对接收到的棋盘信息做一个映射导入进对弈引擎的棋盘信息变量中。

输出的数据被设计为：

- 棋局结束信号：0标识未结束，1表示已经结束

- 胜负方信号：r表示红方胜利，b表示黑方胜利，如果棋局未结束，使用预设的x表示

- 下棋走法信号：[x_src, y_src, x_dst, y_dst]

### 2.2 参考链接

[原始仓库代码](https://gitee.com/SpiritFinches/xqwizard/blob/master/XQWLIGHT/Win32/XQWL06.CPP)

## 3. 运行方式

- 运行环境

蓝区网络

Linux, Ubuntu18.04, g++ --version: g++ (Ubuntu 7.5.0-3ubuntu1~18.04) 7.5.0

gdb --version: GNU gdb (Ubuntu 8.1-0ubuntu3.2) 8.1.0.20180409-git

cmake --version: cmake version 3.10.2

- 配置完C++环境之后，直接编译运行即可。